use serde::Serialize;
use tokio::{
    io::{AsyncReadExt, AsyncWriteExt},
    net::TcpStream,
};

#[tokio::main]
async fn main() {
    println!("Hello, world!");

    let mut stream = TcpStream::connect("127.0.0.1:6379").await.unwrap();

    loop {
        let mut buf = [0; 100];
        let read = stream.read(&mut buf).await.unwrap();

        let msg = String::from_utf8(buf[..read].to_vec()).unwrap();

        let response = serde_json::to_string(&Response {
            test: msg.to_string(),
        })
        .unwrap();

        let length = response.len() as u32;

        stream.write_all(&length.to_be_bytes()).await;
        stream.write_all(&response.as_bytes()).await;

        if read == 0 {
            print!("Lost connection. Exiting...");
            break;
        }

        println!("Read {:?}", String::from_utf8(buf[..read].to_vec()));
    }
}

#[derive(Debug, Serialize)]
struct Response {
    test: String,
}
